
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef rmp400_POSTER_LIB_H
#define rmp400_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "rmp400Type.h"
#include "rmp400Error.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[RMP400_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} RMP400_CNTRL_STR;

/* For consistency with other posters */
typedef RMP400_CNTRL_STR RMP400_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "rmp400PosterLibStruct.h"



/* Posters */
#define RMP400_CNTRL_POSTER_NAME genomInstanceSuffixName("rmp400", "Cntrl")
#define RMP400_MEPOS_POSTER_NAME genomInstanceSuffixName("rmp400", "MEPos")
#define RMP400_ODO_POSTER_NAME genomInstanceSuffixName("rmp400", "Odo")
#define RMP400_REF_POSTER_NAME genomInstanceSuffixName("rmp400", "Ref")
#define RMP400_STATUS_POSTER_NAME genomInstanceSuffixName("rmp400", "Status")
#define RMP400_STATUSGENERIC_POSTER_NAME genomInstanceSuffixName("rmp400", "StatusGeneric")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS rmp400PosterInit ( void );
extern POSTER_ID rmp400CntrlPosterID ();
extern STATUS rmp400CntrlPosterRead ( RMP400_CNTRL_STR *rmp400CntrlStrId );
extern STATUS rmp400CntrlPosterInit ( void );
extern STATUS rmp400CntrlInstancePosterRead(const char *name, RMP400_CNTRL_STR *rmp400CntrlStrId);
extern STATUS rmp400MEPosPosterInit ( void );
extern POSTER_ID rmp400MEPosPosterID ( void );
extern STATUS rmp400MEPosPosterRead ( RMP400_MEPOS_POSTER_STR *x );
extern STATUS rmp400MEPosInstancePosterRead ( const char *, RMP400_MEPOS_POSTER_STR * );
extern STATUS rmp400MEPosmePosPosterRead ( POM_ME_POS *mePos );
extern STATUS rmp400MEPosmePosInstancePosterRead( const char *, POM_ME_POS * );
extern STATUS rmp400OdoPosterInit ( void );
extern POSTER_ID rmp400OdoPosterID ( void );
extern STATUS rmp400OdoPosterRead ( RMP400_ODO_POSTER_STR *x );
extern STATUS rmp400OdoInstancePosterRead ( const char *, RMP400_ODO_POSTER_STR * );
extern STATUS rmp400OdoRobotPosterRead ( GENPOS_CART_STATE *Robot );
extern STATUS rmp400OdoRobotInstancePosterRead( const char *, GENPOS_CART_STATE * );
extern STATUS rmp400OdoVarPosterRead ( GENPOS_CART_CONFIG_VAR *Var );
extern STATUS rmp400OdoVarInstancePosterRead( const char *, GENPOS_CART_CONFIG_VAR * );
extern STATUS rmp400OdoRobot3dPosterRead ( RMP400_CART_3DSTATE *Robot3d );
extern STATUS rmp400OdoRobot3dInstancePosterRead( const char *, RMP400_CART_3DSTATE * );
extern STATUS rmp400RefPosterInit ( void );
extern POSTER_ID rmp400RefPosterID ( void );
extern STATUS rmp400RefPosterRead ( RMP400_REF_POSTER_STR *x );
extern STATUS rmp400RefInstancePosterRead ( const char *, RMP400_REF_POSTER_STR * );
extern STATUS rmp400RefrefPosterRead ( GENPOS_CART_REF *ref );
extern STATUS rmp400RefrefInstancePosterRead( const char *, GENPOS_CART_REF * );
extern STATUS rmp400StatusPosterInit ( void );
extern POSTER_ID rmp400StatusPosterID ( void );
extern STATUS rmp400StatusPosterRead ( RMP400_STATUS_POSTER_STR *x );
extern STATUS rmp400StatusInstancePosterRead ( const char *, RMP400_STATUS_POSTER_STR * );
extern STATUS rmp400StatusstatusPosterRead ( RMP400_STATUS_STR *status );
extern STATUS rmp400StatusstatusInstancePosterRead( const char *, RMP400_STATUS_STR * );
extern STATUS rmp400StatusGenericPosterInit ( void );
extern POSTER_ID rmp400StatusGenericPosterID ( void );
extern STATUS rmp400StatusGenericPosterRead ( RMP400_STATUSGENERIC_POSTER_STR *x );
extern STATUS rmp400StatusGenericInstancePosterRead ( const char *, RMP400_STATUSGENERIC_POSTER_STR * );
extern STATUS rmp400StatusGenericstatusgenPosterRead ( RMP_STATUS_STR *statusgen );
extern STATUS rmp400StatusGenericstatusgenInstancePosterRead( const char *, RMP_STATUS_STR * );
#ifdef __cplusplus
}
#endif
#endif

