
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

/* 
 * rmp400Type.h:     La SDI_F de rmp400
 *
 * Utilise par le module et par les clients
 * (inclut dans rmp400MsgLib.h et rmp400PosterLib.h)
 * 
 */

#ifndef rmp400_TYPE_H
#define rmp400_TYPE_H

#include "genom/modules.h"
#include "rmp400Error.h"

/* Nombre de tache d'execution de ce module */
#define RMP400_NB_EXEC_TASK                   (2)


#endif
#ifndef rmp400_TYPE1_H
#define rmp400_TYPE1_H

#include "/opt/openrobots/include/pom/pomStruct.h"
#include "/opt/openrobots/include/genPos/genPosStruct.h"
#include "/opt/openrobots/include/genBasic/genBasicStruct.h"
#include "/opt/openrobots/include/gyroLib/gyroTypes.h"
#include "rmp400Struct.h"

/*
 * Structure de donnees interne
 */
typedef struct RMP400_STR {
	RMP400_STATUS_STR status;
	RMP_STATUS_STR statusgen;
	GENPOS_CART_STATE robot;
	GENPOS_CART_CONFIG_VAR var;
	GENPOS_CART_REF ref;
	GENPOS_CART_CMD_PARAM cmd;
	RMP400_KINEMATICS_STR kinematics;
	RMP400_VAR_PARAMS varParams;
	GENPOS_POSTER_NAME mePosterName;
	POM_ME_POS mePos;
	RMP400_TRACK_PARAMS trackParams;
	GENPOS_TRACK trackStr;
	RMP400_GYRO gyro;
	RMP400_GYRO_MODE gyroMode;
	RMP400_CART_3DCONFIG setPosStr;
	RMP400_ODOMETRY_MODE odometryMode;
	RMP400_ODOMETRY_METHOD odometryCommand;
	RMP400_CART_3DSTATE robot3d;
	POM_EULER attitude;
	GEN_STRING128 fileName;
	double vCommand;
	double wCommand;
	double vReference;
	double wReference;
	RMP400_GYRO_ASSERV gyroAsserv;
	RMP400_MAX_ACCEL maxAccel;
	double wheelSizeCorrection;
} RMP400_STR;


#endif

