
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef rmp400_TCLSERV_CLIENT_MSG_LIB_H
#define rmp400_TCLSERV_CLIENT_MSG_LIB_H

#include <server/rmp400Type.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int rmp400TclservClientInit (TCLSERV_CLIENT_ID pClientId);

int rmp400TclservClientEnd (TCLSERV_CLIENT_ID clientId);



int rmp400TclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int rmp400TclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rmp400TclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int rmp400TclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int rmp400TclservClientSetCmdParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GENPOS_CART_CMD_PARAM *(in_cmd)
		);

int rmp400TclservClientSetCmdParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rmp400TclservClientSetCmdParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GENPOS_CART_CMD_PARAM *(in_cmd) ,
				 
				 int *bilan);




int rmp400TclservClientSetKinematicsParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 RMP400_KINEMATICS_STR *(in_kinematics)
		);

int rmp400TclservClientSetKinematicsParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rmp400TclservClientSetKinematicsParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 RMP400_KINEMATICS_STR *(in_kinematics) ,
				 
				 int *bilan);




int rmp400TclservClientSetVarParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 RMP400_VAR_PARAMS *(in_varParams)
		);

int rmp400TclservClientSetVarParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rmp400TclservClientSetVarParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 RMP400_VAR_PARAMS *(in_varParams) ,
				 
				 int *bilan);




int rmp400TclservClientStopRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int rmp400TclservClientStopReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rmp400TclservClientStopRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int rmp400TclservClientJoystickOnRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int rmp400TclservClientJoystickOnReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rmp400TclservClientJoystickOnRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int rmp400TclservClientJoystickOnRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int rmp400TclservClientTrackRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 RMP400_TRACK_PARAMS *(in_trackParams) 
		);

int rmp400TclservClientTrackReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rmp400TclservClientTrackRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				RMP400_TRACK_PARAMS *(in_trackParams) ,
				
				int *bilan);

int rmp400TclservClientTrackRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					RMP400_TRACK_PARAMS *(in_trackParams) ,
					
					int *bilan);




int rmp400TclservClientSetPomRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GENPOS_POSTER_NAME *(in_mePosterName) 
		);

int rmp400TclservClientSetPomReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rmp400TclservClientSetPomRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GENPOS_POSTER_NAME *(in_mePosterName) ,
				
				int *bilan);

int rmp400TclservClientSetPomRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GENPOS_POSTER_NAME *(in_mePosterName) ,
					
					int *bilan);




int rmp400TclservClientSetPosRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 RMP400_CART_3DCONFIG *(in_setPosStr)
		);

int rmp400TclservClientSetPosReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rmp400TclservClientSetPosRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 RMP400_CART_3DCONFIG *(in_setPosStr) ,
				 
				 int *bilan);




int rmp400TclservClientGyroRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 RMP400_GYRO_PARAMS *(in_params) 
		);

int rmp400TclservClientGyroReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rmp400TclservClientGyroRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				RMP400_GYRO_PARAMS *(in_params) ,
				
				int *bilan);

int rmp400TclservClientGyroRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					RMP400_GYRO_PARAMS *(in_params) ,
					
					int *bilan);




int rmp400TclservClientGetGyroRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int rmp400TclservClientGetGyroReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       RMP400_GYRO_PARAMS *(out_params),
			       int *bilan);

int rmp400TclservClientGetGyroRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 RMP400_GYRO_PARAMS *(out_params),
				 int *bilan);




int rmp400TclservClientSetOdometryMethodRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 RMP400_ODOMETRY_METHOD *(in_odometryCommand) 
		);

int rmp400TclservClientSetOdometryMethodReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rmp400TclservClientSetOdometryMethodRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				RMP400_ODOMETRY_METHOD *(in_odometryCommand) ,
				
				int *bilan);

int rmp400TclservClientSetOdometryMethodRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					RMP400_ODOMETRY_METHOD *(in_odometryCommand) ,
					
					int *bilan);




int rmp400TclservClientSetWheelSizeCorrectionRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 double *(in_wheelSizeCorrection)
		);

int rmp400TclservClientSetWheelSizeCorrectionReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rmp400TclservClientSetWheelSizeCorrectionRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 double *(in_wheelSizeCorrection) ,
				 
				 int *bilan);




int rmp400TclservClientLogRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GEN_STRING128 *(in_fileName) 
		);

int rmp400TclservClientLogReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rmp400TclservClientLogRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GEN_STRING128 *(in_fileName) ,
				
				int *bilan);

int rmp400TclservClientLogRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GEN_STRING128 *(in_fileName) ,
					
					int *bilan);




int rmp400TclservClientStopLogRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int rmp400TclservClientStopLogReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rmp400TclservClientStopLogRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int rmp400TclservClientLogInternalDataRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GEN_STRING128 *(in_fileName) 
		);

int rmp400TclservClientLogInternalDataReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rmp400TclservClientLogInternalDataRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GEN_STRING128 *(in_fileName) ,
				
				int *bilan);

int rmp400TclservClientLogInternalDataRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GEN_STRING128 *(in_fileName) ,
					
					int *bilan);




int rmp400TclservClientStopInternalDataLogRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int rmp400TclservClientStopInternalDataLogReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rmp400TclservClientStopInternalDataLogRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int rmp400TclservClientGotoRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GENPOS_CART_REF *(in_ref)
		);

int rmp400TclservClientGotoReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rmp400TclservClientGotoRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GENPOS_CART_REF *(in_ref) ,
				 
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* rmp400TCLSERV_CLIENT_MSG_LIB_H */

